'use strict';

exports.__esModule = true;
exports.CONTEXT_CHANNEL_SHAPE = exports.CHANNEL = undefined;

var _MidiDeviceProvider$c, _MidiDeviceProvider$c2;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _utils = require('../utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var babelPluginFlowReactPropTypes_proptype_Node = require('react').babelPluginFlowReactPropTypes_proptype_Node || require('prop-types').any;

var babelPluginFlowReactPropTypes_proptype_Broadcast = require('../utils').babelPluginFlowReactPropTypes_proptype_Broadcast || require('prop-types').any;

var CHANNEL = exports.CHANNEL = '__midi-device-provider__';
var CONTEXT_CHANNEL_SHAPE = exports.CONTEXT_CHANNEL_SHAPE = _propTypes2.default.shape({
  setMidiInput: _propTypes2.default.func,
  setMidiOutput: _propTypes2.default.func,
  subscribe: _propTypes2.default.func
});

var MidiDeviceProvider = function (_Component) {
  _inherits(MidiDeviceProvider, _Component);

  function MidiDeviceProvider() {
    _classCallCheck(this, MidiDeviceProvider);

    var _this = _possibleConstructorReturn(this, _Component.call(this));

    _this.broadcast = (0, _utils.createBroadcast)({
      inputs: [],
      outputs: [],
      selectedInput: null,
      selectedOutput: null
    });


    _this.setMidiInput = _this.setMidiInput.bind(_this);
    _this.setMidiOutput = _this.setMidiOutput.bind(_this);
    return _this;
  }

  MidiDeviceProvider.prototype.getChildContext = function getChildContext() {
    var _extends2;

    return _extends({}, this.context, (_extends2 = {}, _extends2[CHANNEL] = {
      subscribe: this.broadcast.subscribe,
      setMidiInput: this.setMidiInput,
      setMidiOutput: this.setMidiOutput
    }, _extends2));
  };

  MidiDeviceProvider.prototype.componentWillMount = function componentWillMount() {
    var _this2 = this;

    var duplicateContext = this.context[CHANNEL];
    if (duplicateContext !== undefined) {
      console.warn('[MidiDeviceProvider] - It looks like you are trying to nest multiple providers. This probably won\'t have the outcome you expect. Any nested MidiDeviceProviders will be disabled.');
      return;
    }

    (0, _utils.getMidiAccess)(this.props.sysex).then(function (access) {
      _this2.broadcast.publish((0, _utils.mapMidiIO)(access));
      // eslint-disable-next-line no-param-reassign
      access.onstatechange = function () {
        _this2.broadcast.publish((0, _utils.mapMidiIO)(access));
      };
    }).catch(function (err) {
      console.warn('[MidiDeviceProvider] - ' + err);
    });
  };

  MidiDeviceProvider.prototype.setMidiInput = function setMidiInput(input) {
    this.broadcast.publish({ selectedInput: input });
  };

  MidiDeviceProvider.prototype.setMidiOutput = function setMidiOutput(output) {
    this.broadcast.publish({ selectedOutput: output });
  };

  MidiDeviceProvider.prototype.render = function render() {
    return !this.props.children ? null : _react2.default.Children.only(this.props.children);
  };

  return MidiDeviceProvider;
}(_react.Component);

MidiDeviceProvider.defaultProps = {
  children: null,
  sysex: false
};
MidiDeviceProvider.propTypes = {
  children: typeof babelPluginFlowReactPropTypes_proptype_Node === 'function' ? babelPluginFlowReactPropTypes_proptype_Node : require('prop-types').shape(babelPluginFlowReactPropTypes_proptype_Node),
  sysex: require('prop-types').bool
};
MidiDeviceProvider.propTypes = {
  children: typeof babelPluginFlowReactPropTypes_proptype_Node === 'function' ? babelPluginFlowReactPropTypes_proptype_Node : require('prop-types').shape(babelPluginFlowReactPropTypes_proptype_Node),
  sysex: require('prop-types').bool
};


MidiDeviceProvider.childContextTypes = (_MidiDeviceProvider$c = {}, _MidiDeviceProvider$c[CHANNEL] = CONTEXT_CHANNEL_SHAPE, _MidiDeviceProvider$c);

MidiDeviceProvider.contextTypes = (_MidiDeviceProvider$c2 = {}, _MidiDeviceProvider$c2[CHANNEL] = CONTEXT_CHANNEL_SHAPE, _MidiDeviceProvider$c2);

exports.default = MidiDeviceProvider;