"use strict";

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports.createBroadcast = createBroadcast;
var babelPluginFlowReactPropTypes_proptype_Broadcast = {
  publish: require("prop-types").func.isRequired,
  subscribe: require("prop-types").func.isRequired
};
if (typeof exports !== "undefined") Object.defineProperty(exports, "babelPluginFlowReactPropTypes_proptype_Broadcast", {
  value: babelPluginFlowReactPropTypes_proptype_Broadcast,
  configurable: true,
  enumerable: true
});
function createBroadcast(initialState) {
  var listeners = [];
  var state = initialState;

  function publish(nextState) {
    state = _extends({}, state, nextState);

    listeners.forEach(function (listener) {
      listener(state);
    });
  }

  function subscribe(listener) {
    listeners.push(listener);
    listener(state);
    return function () {
      listeners = listeners.filter(function (l) {
        return l !== listener;
      });
    };
  }

  return { publish: publish, subscribe: subscribe };
}

exports.default = createBroadcast;