'use strict';

exports.__esModule = true;
exports.getMidiAccess = getMidiAccess;
function getMidiAccess() {
  var sysex = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;

  return typeof window !== 'undefined' && window.navigator && typeof window.navigator.requestMIDIAccess === 'function' ? window.navigator.requestMIDIAccess({ sysex: sysex }).then(function (access) {
    return access;
  }) : new Promise(function (resolve, reject) {
    return reject(new Error('MIDI Not Available'));
  });
}

exports.default = getMidiAccess;